require 'spec_helper'

describe EM::MeshRuby do
  let(:mesh) do
    EM::MeshRuby.new('123', '456', '3rdPartyMeshBlueGateway.com')
  end

  it "initializes" do
    expect(mesh).to be_kind_of(EM::MeshRuby)
    expect(mesh.socket).to be_kind_of(SocketIO::Client::Simple::Client)
    expect(mesh.queue).to be_kind_of(EM::Queue)
    expect(mesh.uuid).to eq('123')
    expect(mesh.token).to eq('456')
    expect(mesh.url).to eq('3rdPartyMeshBlueGateway.com')
  end

  it "Pushes all kinds of messages" do
    mesh.queue = []
    # Good JSON
    mesh.push '{"abc": 123}'
    expect(mesh.queue.pop).to eq({"abc" => 123})
    # Bad JSON
    mesh.push('{{{')
    expect(mesh.queue.pop).to eq('{{{')
    # Unidentified Flying Objects
    mesh.push(Thread)
    expect(mesh.queue.pop).to eq(Thread)
  end
end
